--[[
==myHonor==
By Smokey aka Mahuatahu on Earthen Ring Horde US

==Version==	
1.1.0

==To do list==
1.) Honor per hour --not sure how i want to do this yet, work in progress
2.) (maybe?) own GUI instead of data broker --too lazy now, convenient when built into Titan Panel or FuBar
3.) Honor, and conquest goals.
==Changelog==
1.1.0 -- Released to public, finally a "finished product"
1.0 -- Just made
--]]


-- Short configuration
local useSI = true					--[[	true: SI-units, e.g. 3.2k instead of 3230			]]
-- Configuration end

local suffixes = {
	"Total Honor Pts",
	"Honor Today",
	"BG Honor",
	"Honor",
}

local function siUnits(value)
	if(not useSI) then
		return value
	elseif(not value or value == 0) then
		return 0
	elseif(value >= 10^3) then
		return ("%.1fk"):format(value / 10^3)
	elseif(value >= 10^6) then
		return ("%.1fm"):format(value / 10^6)
	else
		return value
	end
end

local function texturizeIcon(arg1)
	return format("|T%s:15:15:0:0|t", type(arg1) == "number" and GetItemIcon(arg1) or arg1)
end

-- Initializing the object and frame
local honorIcon = "Interface\\PVPFrame\\PVP-Currency-"..UnitFactionGroup("player")
--local arenaIcon = [[Interface\PVPFrame\PVP-ArenaPoints-Icon]]

local OnEvent = function(self, event, ...) self[event](self, event, ...) end
local dataobj = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("myHonor", {
	type = "data source",
	text = "0 total",
	value = "0",
	icon = honorIcon,
	suffix = " Total Honor Pts",
})
local frame = CreateFrame"Frame"

-- [[    Update the display !    ]] --
local session, total, startTime
local startHonor, isBG
local HonorGained, SessionHonor, StartingHonor, BGHonor, LastBG, HonorBefore = 0, 0, 0, 0, 0, 0, 0, 0, 0
local HonorGained_InBG = 0
local BGCount = 0
local AvgHonor = 0
local EnteredBG = 0
local InBG = 0
function frame:CHAT_MSG_COMBAT_HONOR_GAIN()
	local displ = myHonor.displ
	local value

HonorGained = (select(2,GetCurrencyInfo(HONOR_CURRENCY)))
SessionHonor = (select(2,GetCurrencyInfo(HONOR_CURRENCY))) - StartingHonor
BGHonor = (select(2,GetCurrencyInfo(HONOR_CURRENCY))) - HonorBefore
if (BGCount>0) then
AvgHonor = HonorGained_InBG / BGCount   
end

	if(displ == 4) then
		if(isBG) then
			value = BGHonor.. " | "..siUnits(SessionHonor).." | "
		elseif(SessionHonor > 0) then
			value = siUnits(SessionHonor).." | "
		else
			value = ""
		end
		value = value..HonorGained
	--elseif(displ == 4) then
	--	value =  arena
	elseif(displ == 3) then
		value = BGHonor
	elseif(displ == 2) then
		value = siUnits(SessionHonor)
	else
		value = HonorGained
	end
	dataobj.value = value
	dataobj.text = value.." "..dataobj.suffix
end

--[[   Initialize all variables    ]] --
function frame:PLAYER_ENTERING_WORLD()
	if(not myHonor) then myHonor = {} end
	  ZoneInfo = (select(2, IsInInstance()))
	  InBG = 0
	  if (ZoneInfo == "pvp") then
	     InBG = 1 --In a battleground
 	     BGCount = BGCount + 1
	     HonorGained_InBG = HonorGained_InBG + BGHonor
	     LastBG = BGHonor
	     BGHonor = 0
         HonorBefore = (select(2,GetCurrencyInfo(HONOR_CURRENCY)))
	  else
	     InBG = 0 --Not in a battleground
	  end
	--if(cargoHonor.displ == 4) then dataobj.icon = [[Interface\PVPFrame\PVP-ArenaPoints-Icon]] end
	self:CHAT_MSG_COMBAT_HONOR_GAIN()
end

frame:SetScript("OnEvent", OnEvent)
frame:RegisterEvent"CHAT_MSG_COMBAT_HONOR_GAIN"
frame:RegisterEvent"PLAYER_ENTERING_WORLD"

-- [[   The tooltip  ]] --
function dataobj.OnTooltipShow(tooltip)

	 local hc, InBGtext, pname, rname, fname = 0, 0, 0, 0, 0
     pname = GetHighText(UnitName("player"))
     rname = GreenText(GetCVar("realmname"))
     fname = UnitFactionGroup("player")
     hc = GetPVPLifetimeStats()
     if (InBG==1) then
     InBGtext = RedText(GetZoneText())
     else 
     InBGtext = GreenText("Not currently in BG")
     end
	-- Honor Stats
	session = select(2, GetPVPSessionStats())
	_, total = GetCurrencyInfo(392)
	--total = siUnits(total)
	local perHour
	if(startTime) then perHour = (session-startSession)/((time()-startTime)/3600) end
	if (fname=="Alliance") then
        fname = BlueText(UnitFactionGroup("player"))
     else
        fname = RedText(UnitFactionGroup("player"))
     end
	-- Arena points
	--local arena = GetArenaCurrency()
	--if(arena > 0) then
	--	tooltip:AddDoubleLine("Arena points:", arena.." "..texturizeIcon(arenaIcon), 1,1,1, 0,1,0)
	--end
	tooltip:AddLine(pname.." - "..rname.." ("..fname..")")
	tooltip:AddDoubleLine(myHonor_TT_STATUS,InBGtext)
	tooltip:AddDoubleLine(myHonor_TT_SESSIONPTS,GetHighText(SessionHonor))
	tooltip:AddDoubleLine(myHonor_TT_TOTALPTS,GetHighText(StartingHonor))
	tooltip:AddDoubleLine(myHonor_TT_TOTALHKS,GetHighText(hc))
	tooltip:AddLine("----------------------------------")
	tooltip:AddDoubleLine(GetHighText(myHonor_TT_BGSTATS))
	tooltip:AddDoubleLine(myHonor_TT_LASTBG,Should_I_Be_Red(LastBG))
	tooltip:AddDoubleLine(myHonor_TT_BGHONOR,Should_I_Be_Red(BGHonor))
	tooltip:AddDoubleLine(myHonor_TT_AVGHONOR,Should_I_Be_Red(AvgHonor))
	tooltip:AddDoubleLine(myHonor_TT_BGCOUNT,Should_I_Be_Red(BGCount))
	tooltip:AddLine(" ")
	--tooltip:AddLine("Click to toggle display")
	tooltip:AddLine("Right-click to open PvP-Panel")
	tooltip.updateFunction = dataobj.OnTooltipShow
end

function dataobj.OnClick(self, button)
	if(button == "RightButton") then
		TogglePVPFrame()
	else
		--myHonor.displ = (myHonor.displ == 4 and 1) or (myHonor.displ and myHonor.displ+1) or 2
		local displ = myHonor.displ
		--if(displ == 4) then
		--	dataobj.icon = arenaIcon
		--else
		if(displ == 4) then
			dataobj.icon = honorIcon
		end
		dataobj.suffix = suffixes[displ]
		frame:CHAT_MSG_COMBAT_HONOR_GAIN()
	end
end

function GreenText(text)

	if (text) then
		return "|cff00ff00"..text.."|r"
	end 

end

function RedText(text)

	if (text) then
		return "|cffff0000"..text.."|r"
	end 

end

function BlueText(text)

	if (text) then
		return "|cff0000ff"..text.."|r"
	end 

end

function GetHighText(text)

	if (text) then
		return "|cffffffff"..text.."|r"
	end

end

function Should_I_Be_Red(text)
	if (text) then
		if (text==0) then
			return RedText(text);
		else
			return GreenText(text);
		end
	end
end